//============================================================================//
//
//  Software Name : MEGADOCK
//
//  Class Name : Parallel
//
//  Contact address : Tokyo Institute of Technology, AKIYAMA Lab.
//
//============================================================================//

#ifndef Parallel_h
#define Parallel_h 1

#include <stdlib.h>
#include <time.h>
#include <sys/time.h>

#ifdef _OPENMP
#include <omp.h>
#endif

class Parallel
{
private:
    Parallel(Parallel &c) {}
    int       _Nproc2;
    int       _Num_gpu; //shimoda130510
public:
    Parallel(const int &nproc2) : _Nproc2(nproc2) {
#ifdef DEBUG
        cout << "Constructing Parallel.\n";
#endif
    }
    virtual   ~Parallel()     {
#ifdef DEBUG
        cout << "Destructing Parallel.\n";
#endif
    }
    void      nproc2(int i)       {
        _Nproc2 = i;
    }
    int       nproc2()        {
        return _Nproc2;
    }
    void      num_gpu(int i)       {//shimoda130510
        _Num_gpu = i;
    }
    int       num_gpu()        { //shimoda130510
        return _Num_gpu;
    }
};

#endif
